Bug 124651 - www/apache22: WITH_LDAP: Broken
Summary: www/apache22: WITH_LDAP: Broken
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Clement Laforet
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-06-16 21:30 UTC by Larry Rosenman
Modified: 2008-12-17 13:35 UTC (History)
0 users

See Also:


Attachments
www_apache22-ports_124651.diff (761 bytes, patch)
2008-07-16 17:48 UTC, pgollucci
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Larry Rosenman freebsd_committer 2008-06-16 21:30:02 UTC
	Installing a new VM, and when I went to build www/apache22 and checked 
the LDAP box on the options screen, and then we get a compile error.  
        I originally didn't have openldap installed, but the same thing 
happens with it installed.

Fix: 

Unknown.
How-To-Repeat: attempt to make www/apache22.

output:

===>  Building for apache-2.2.8
Making all in srclib
Making all in apr
Making all in apr-util
Making all in pcre
Making all in os
Making all in unix
Making all in server
Making all in mpm
Making all in prefork
Making all in modules
Making all in aaa
Making all in cache
Making all in debug
Making all in filters
Making all in loggers
Making all in metadata
Making all in ssl
Making all in http
Making all in dav/main
Making all in generators
Making all in dav/fs
Making all in mappers
Making all in support

Building shared: mod_authn_file.la mod_authn_dbm.la mod_authn_anon.la mod_authn_default.la mod_authn_alias.la mod_authz_host.la mod_authz_groupfile.la mod_authz_user.la mod_authz_dbm.la mod_authz_owner.la mod_authnz_ldap.la mod_authz_default.la mod_auth_basic.la mod_auth_digest.la
/usr/ports/www/apache22/work/httpd-2.2.8/srclib/apr/libtool --silent --mode=compile cc   -O2 -fno-strict-aliasing -pipe -I/usr/include      -I/usr/ports/www/apache22/work/httpd-2.2.8/srclib/pcre -I. -I/usr/ports/www/apache22/work/httpd-2.2.8/os/unix -I/usr/ports/www/apache22/work/httpd-2.2.8/server/mpm/prefork -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/http -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/filters -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/proxy -I/usr/ports/www/apache22/work/httpd-2.2.8/include -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/generators -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/mappers -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/database -I/usr/ports/www/apache22/work/httpd-2.2.8/srclib/apr/include -I/usr/ports/www/apache22/work/httpd-2.2.8/srclib/apr-util/include -I/usr/local/include -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/proxy/../generators -I/usr/include -I/usr/ports/www/apache22/work/httpd-2
 .2.8/modules/ssl -I/usr/ports/www/apache22/work/httpd-2.2.8/modules/dav/main -prefer-pic -c mod_authnz_ldap.c && touch mod_authnz_ldap.slo
mod_authnz_ldap.c:41:2: error: #error mod_authnz_ldap requires APR-util to have LDAP support built in. To fix add --with-ldap to ./configure.
mod_authnz_ldap.c:63: error: expected specifier-qualifier-list before 'deref_options'
mod_authnz_ldap.c:94: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:95: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:96: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:97: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:98: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:99: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c:100: error: expected '=', ',', ';', 'asm' or '__attribute__' before '*' token
mod_authnz_ldap.c: In function 'create_authnz_ldap_dir_config':
mod_authnz_ldap.c:289: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:292: error: 'authn_ldap_config_t' has no member named 'have_ldap_url'
mod_authnz_ldap.c:295: error: 'authn_ldap_config_t' has no member named 'binddn'
mod_authnz_ldap.c:296: error: 'authn_ldap_config_t' has no member named 'bindpw'
mod_authnz_ldap.c:297: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:297: error: 'always' undeclared (first use in this function)
mod_authnz_ldap.c:297: error: (Each undeclared identifier is reported only once
mod_authnz_ldap.c:297: error: for each function it appears in.)
mod_authnz_ldap.c:298: error: 'authn_ldap_config_t' has no member named 'group_attrib_is_dn'
mod_authnz_ldap.c:305: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:307: error: 'authn_ldap_config_t' has no member named 'user_is_dn'
mod_authnz_ldap.c:308: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c:309: error: 'authn_ldap_config_t' has no member named 'compare_dn_on_server'
mod_authnz_ldap.c: In function 'authnz_ldap_cleanup_connection_close':
mod_authnz_ldap.c:316: error: 'util_ldap_connection_t' undeclared (first use in this function)
mod_authnz_ldap.c:316: error: 'ldc' undeclared (first use in this function)
mod_authnz_ldap.c: In function 'authn_ldap_check_password':
mod_authnz_ldap.c:341: error: 'util_ldap_connection_t' undeclared (first use in this function)
mod_authnz_ldap.c:341: error: 'ldc' undeclared (first use in this function)
mod_authnz_ldap.c:359: error: 'authn_ldap_config_t' has no member named 'have_ldap_url'
mod_authnz_ldap.c:368: error: 'authn_ldap_config_t' has no member named 'binddn'
mod_authnz_ldap.c:368: error: 'authn_ldap_config_t' has no member named 'bindpw'
mod_authnz_ldap.c:368: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:369: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:404: error: 'LDAP_SERVER_DOWN' undeclared (first use in this function)
mod_authnz_ldap.c:411: error: 'LDAP_SUCCESS' undeclared (first use in this function)
mod_authnz_ldap.c:417: error: 'LDAP_NO_SUCH_OBJECT' undeclared (first use in this function)
mod_authnz_ldap.c:421: error: 'LDAP_INAPPROPRIATE_AUTH' undeclared (first use in this function)
mod_authnz_ldap.c:422: error: 'LDAP_INVALID_CREDENTIALS' undeclared (first use in this function)
mod_authnz_ldap.c:436: error: 'authn_ldap_config_t' has no member named 'user_is_dn'
mod_authnz_ldap.c:454: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c:455: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c:464: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c:471: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c: In function 'authz_ldap_check_user_access':
mod_authnz_ldap.c:504: error: 'util_ldap_connection_t' undeclared (first use in this function)
mod_authnz_ldap.c:504: error: 'ldc' undeclared (first use in this function)
mod_authnz_ldap.c:526: error: 'authn_ldap_config_t' has no member named 'have_ldap_url'
mod_authnz_ldap.c:532: error: 'authn_ldap_config_t' has no member named 'binddn'
mod_authnz_ldap.c:532: error: 'authn_ldap_config_t' has no member named 'bindpw'
mod_authnz_ldap.c:532: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:533: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:548: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:553: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:555: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:593: error: 'LDAP_SUCCESS' undeclared (first use in this function)
mod_authnz_ldap.c:632: error: 'LDAP_COMPARE_TRUE' undeclared (first use in this function)
mod_authnz_ldap.c:677: error: 'authn_ldap_config_t' has no member named 'compare_dn_on_server'
mod_authnz_ldap.c:694: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:698: error: 'authn_ldap_config_t' has no member named 'group_attrib_is_dn'
mod_authnz_ldap.c:720: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:724: error: 'authn_ldap_config_t' has no member named 'group_attrib_is_dn'
mod_authnz_ldap.c:727: error: 'authn_ldap_config_t' has no member named 'group_attrib_is_dn'
mod_authnz_ldap.c:808: error: 'authn_ldap_config_t' has no member named 'compare_dn_on_server'
mod_authnz_ldap.c:819: error: 'LDAP_FILTER_ERROR' undeclared (first use in this function)
mod_authnz_ldap.c: In function 'mod_auth_ldap_parse_url':
mod_authnz_ldap.c:870: error: 'apr_ldap_url_desc_t' undeclared (first use in this function)
mod_authnz_ldap.c:870: error: 'urld' undeclared (first use in this function)
mod_authnz_ldap.c:871: error: 'apr_ldap_err_t' undeclared (first use in this function)
mod_authnz_ldap.c:871: error: 'result' undeclared (first use in this function)
mod_authnz_ldap.c:894: error: 'LDAP_SCOPE_SUBTREE' undeclared (first use in this function)
mod_authnz_ldap.c:895: error: 'LDAP_SCOPE_BASE' undeclared (first use in this function)
mod_authnz_ldap.c:896: error: 'LDAP_SCOPE_ONELEVEL' undeclared (first use in this function)
mod_authnz_ldap.c:951: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:951: error: 'APR_LDAP_NONE' undeclared (first use in this function)
mod_authnz_ldap.c:954: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:954: error: 'APR_LDAP_SSL' undeclared (first use in this function)
mod_authnz_ldap.c:957: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:957: error: 'APR_LDAP_STARTTLS' undeclared (first use in this function)
mod_authnz_ldap.c:969: error: 'authn_ldap_config_t' has no member named 'secure'
mod_authnz_ldap.c:970: error: 'LDAPS_PORT' undeclared (first use in this function)
mod_authnz_ldap.c:976: error: 'LDAP_PORT' undeclared (first use in this function)
mod_authnz_ldap.c:981: error: 'authn_ldap_config_t' has no member named 'have_ldap_url'
mod_authnz_ldap.c: In function 'mod_auth_ldap_set_deref':
mod_authnz_ldap.c:991: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:991: error: 'never' undeclared (first use in this function)
mod_authnz_ldap.c:994: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:994: error: 'searching' undeclared (first use in this function)
mod_authnz_ldap.c:997: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:997: error: 'finding' undeclared (first use in this function)
mod_authnz_ldap.c:1000: error: 'authn_ldap_config_t' has no member named 'deref'
mod_authnz_ldap.c:1000: error: 'always' undeclared (first use in this function)
mod_authnz_ldap.c: In function 'mod_auth_ldap_add_group_attribute':
mod_authnz_ldap.c:1014: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c:1017: error: 'authn_ldap_config_t' has no member named 'groupattr'
mod_authnz_ldap.c: At top level:
mod_authnz_ldap.c:1056: error: 'authn_ldap_config_t' has no member named 'binddn'
mod_authnz_ldap.c:1060: error: 'authn_ldap_config_t' has no member named 'bindpw'
mod_authnz_ldap.c:1064: error: 'authn_ldap_config_t' has no member named 'user_is_dn'
mod_authnz_ldap.c:1070: error: 'authn_ldap_config_t' has no member named 'remote_user_attribute'
mod_authnz_ldap.c:1082: error: 'authn_ldap_config_t' has no member named 'compare_dn_on_server'
mod_authnz_ldap.c:1093: error: 'authn_ldap_config_t' has no member named 'group_attrib_is_dn'
mod_authnz_ldap.c: In function 'ImportULDAPOptFn':
mod_authnz_ldap.c:1207: error: 'util_ldap_connection_close' undeclared (first use in this function)
mod_authnz_ldap.c:1207: error: 'apr_OFN_uldap_connection_close_t' undeclared (first use in this function)
mod_authnz_ldap.c:1207: error: expected expression before ')' token
mod_authnz_ldap.c:1207: error: invalid operands to binary *
mod_authnz_ldap.c:1208: error: 'util_ldap_connection_find' undeclared (first use in this function)
mod_authnz_ldap.c:1208: error: 'apr_OFN_uldap_connection_find_t' undeclared (first use in this function)
mod_authnz_ldap.c:1208: error: expected expression before ')' token
mod_authnz_ldap.c:1208: error: invalid operands to binary *
mod_authnz_ldap.c:1209: error: 'util_ldap_cache_comparedn' undeclared (first use in this function)
mod_authnz_ldap.c:1209: error: 'apr_OFN_uldap_cache_comparedn_t' undeclared (first use in this function)
mod_authnz_ldap.c:1209: error: expected expression before ')' token
mod_authnz_ldap.c:1209: error: invalid operands to binary *
mod_authnz_ldap.c:1210: error: 'util_ldap_cache_compare' undeclared (first use in this function)
mod_authnz_ldap.c:1210: error: 'apr_OFN_uldap_cache_compare_t' undeclared (first use in this function)
mod_authnz_ldap.c:1210: error: expected expression before ')' token
mod_authnz_ldap.c:1210: error: invalid operands to binary *
mod_authnz_ldap.c:1211: error: 'util_ldap_cache_checkuserid' undeclared (first use in this function)
mod_authnz_ldap.c:1211: error: 'apr_OFN_uldap_cache_checkuserid_t' undeclared (first use in this function)
mod_authnz_ldap.c:1211: error: expected expression before ')' token
mod_authnz_ldap.c:1211: error: invalid operands to binary *
mod_authnz_ldap.c:1212: error: 'util_ldap_cache_getuserdn' undeclared (first use in this function)
mod_authnz_ldap.c:1212: error: 'apr_OFN_uldap_cache_getuserdn_t' undeclared (first use in this function)
mod_authnz_ldap.c:1212: error: expected expression before ')' token
mod_authnz_ldap.c:1212: error: invalid operands to binary *
mod_authnz_ldap.c:1213: error: 'util_ldap_ssl_supported' undeclared (first use in this function)
mod_authnz_ldap.c:1213: error: 'apr_OFN_uldap_ssl_supported_t' undeclared (first use in this function)
mod_authnz_ldap.c:1213: error: expected expression before ')' token
mod_authnz_ldap.c:1213: error: invalid operands to binary *
*** Error code 1

Stop in /usr/ports/www/apache22/work/httpd-2.2.8/modules/aaa.
*** Error code 1

Stop in /usr/ports/www/apache22/work/httpd-2.2.8/modules/aaa.
*** Error code 1

Stop in /usr/ports/www/apache22/work/httpd-2.2.8/modules.
*** Error code 1

Stop in /usr/ports/www/apache22/work/httpd-2.2.8.
*** Error code 1

Stop in /usr/ports/www/apache22/work/httpd-2.2.8.
*** Error code 1

Stop in /usr/ports/www/apache22.
*** Error code 1

Stop in /usr/ports/www/apache22.
Comment 1 Edwin Groothuis freebsd_committer 2008-06-16 21:30:12 UTC
Responsible Changed
From-To: freebsd-ports-bugs->clement

Over to maintainer (via the GNATS Auto Assign Tool)
Comment 2 Larry Rosenman freebsd_committer 2008-06-16 21:53:45 UTC
Ok, it looks like if you don't pick LDAP in addition to the mod_authnz_ldap,
you don't get an APR that uses the LDAP libs, and causes this issue. 

Maybe that should be checked for as well?



-- 
Larry Rosenman                     http://www.lerctr.org/~ler
Phone: +1 512-248-2683                E-Mail: ler@lerctr.org
US Mail: 430 Valona Loop, Round Rock, TX 78681-3893
Comment 3 Larry Rosenman freebsd_committer 2008-06-16 22:06:09 UTC
Ok, it looks like if you don't pick LDAP in addition to the mod_authnz_ldap,
you don't get an APR that uses the LDAP libs, and causes this issue. 

Maybe that should be checked for as well?


-- 
Larry Rosenman                     http://www.lerctr.org/~ler
Phone: +1 512-248-2683                E-Mail: ler@lerctr.org
US Mail: 430 Valona Loop, Round Rock, TX 78681-3893
Comment 4 pgollucci 2008-07-16 17:08:53 UTC
Can you please provide the full contents
of after you have run 'make config'

/var/db/ports/apache22/options

Thanks.


-- 
------------------------------------------------------------------------
Philip M. Gollucci (philip@ridecharge.com)
o:703.549.2050x206
Senior System Admin - Riderway, Inc.
http://riderway.com / http://ridecharge.com
1024D/DB9B8C1C B90B FBC3 A3A1 C71A 8E70  3F8C 75B8 8FFB DB9B 8C1C

Work like you don't need the money,
love like you'll never get hurt,
and dance like nobody's watching.
Comment 5 Larry Rosenman freebsd_committer 2008-07-16 17:10:38 UTC
I've already corresponded with the maintainer, and it was a fault of not
having the APR library built with WITH_LDAP (there is no interlock on the
options). 

I don't have the issue any more, and the port should make sure that options
dependencies are all checked. 

Thanks!


-- 
Larry Rosenman                     http://www.lerctr.org/~ler
Phone: +1 512-248-2683                E-Mail: ler@lerctr.org
US Mail: 430 Valona Loop, Round Rock, TX 78681-3893


-----Original Message-----
From: Philip M. Gollucci [mailto:pgollucci@ridecharge.com] 
Sent: Wednesday, July 16, 2008 11:09 AM
To: bug-followup@FreeBSD.org; ler@lerctr.org
Subject: Re: ports/124651: www/apache22: WITH_LDAP: Broken

Can you please provide the full contents
of after you have run 'make config'

/var/db/ports/apache22/options

Thanks.


-- 
------------------------------------------------------------------------
Philip M. Gollucci (philip@ridecharge.com)
o:703.549.2050x206
Senior System Admin - Riderway, Inc.
http://riderway.com / http://ridecharge.com
1024D/DB9B8C1C B90B FBC3 A3A1 C71A 8E70  3F8C 75B8 8FFB DB9B 8C1C

Work like you don't need the money,
love like you'll never get hurt,
and dance like nobody's watching.
Comment 6 pgollucci 2008-07-16 17:48:46 UTC
Feedback received via e-mail

Heres a fix.

Patch attached.

-- 
------------------------------------------------------------------------
Philip M. Gollucci (philip@ridecharge.com)
o:703.549.2050x206
Senior System Admin - Riderway, Inc.
http://riderway.com / http://ridecharge.com
1024D/DB9B8C1C B90B FBC3 A3A1 C71A 8E70  3F8C 75B8 8FFB DB9B 8C1C

Work like you don't need the money,
love like you'll never get hurt,
and dance like nobody's watching.
Comment 7 Pav Lucistnik freebsd_committer 2008-12-17 13:34:03 UTC
State Changed
From-To: open->closed

Current revision of the port enables LDAP option when AUTHNZ_LDAP option is 
enabled